export class Position {
    constructor(x, y, z) {
        this.x = Math.floor(x);
        this.y = Math.floor(y);
        this.z = Math.floor(z);
    }
    place() {
        return `${this.x} ${this.y} ${this.z}`;
    }
    formatted() {
        return `${this.x}, ${this.y}, ${this.z}`;
    }
}


import { world as World } from "mojang-minecraft";
var startedUp = false
var brushpos = new Position(0, 0, 0)
var pyrpos, paste, size
const overworld = World.getDimension("overworld")
var structure = "sphere"
var allPlayers = World.getPlayers()


overworld.runCommand(`function setup`)
var pos1 = new Position(0, 0, 0)
var pos2 = new Position(0, 0, 0)


World.events.tick.subscribe(() => {
    if (!startedUp) {
        overworld.runCommand("tag @a add op")
        startedUp = true
    }

    overworld.runCommand(`titleraw @a actionbar {"rawtext":[{"text":"§b${pos1.formatted()}  §l->  §r§b${pos2.formatted()}"}]}`)
    overworld.runCommand(`execute @a[scores={brush=1}] ^ ^ ^30 structure load ${structure} ~${brushpos.x} ~${brushpos.y} ~${brushpos.z}`)
    overworld.runCommand(`scoreboard players set @a[scores={brush=1}] brush 0`)
    overworld.runCommand(`execute @a[tag=!join] ~ ~ ~ function join`)
})


World.events.entityCreate.subscribe(evd => {
    let id = evd.entity.id
    let location = evd.entity.location
    if (id === 'wwe:set1') {
        pos1 = new Position(location.x, location.y - 1, location.z)
        overworld.runCommand(`event entity @e[type=wwe:set1] despawn`)
        overworld.runCommand(`tellraw @a {"rawtext":[{"text":"§dFirst position set: ${pos1.formatted()}"}]}`)
    }
    else if (id === 'wwe:set2') {
        pos2 = new Position(location.x, location.y - 1, location.z)
        overworld.runCommand(`event entity @e[type=wwe:set2] despawn`)
        overworld.runCommand(`tellraw @a {"rawtext":[{"text":"§dSecond position set: ${pos2.formatted()}"}]}`)
    }
})


World.events.beforeChat.subscribe(evd => {
    let msg = evd.message
    let sender = evd.sender
    let cmd = '!'
    let output = overworld.runCommand(`tag "${sender.name}" list`).statusMessage.replace(/§./g, '').match(/(?<=: ).*$/g)?.[0] ?? ''.split(',')
    var args = msg.replace('!', '').split(' ')
    if (output.includes('op') && msg.startsWith(`${cmd}`) == false) {
        evd.cancel = true
        sender.runCommand(`tellraw @a {"rawtext":[{"text":"§7[§dOperator§7] §r<${sender.name}> ${msg}"}]}`)
    }
    else if (output.includes('op') && msg.startsWith(`${cmd}`)) {
        evd.cancel = true
        switch (args[0]) {
            case ('admins'): {
                sender.runCommand(`tellraw @s {"rawtext":[{"text":"§l§badmins online:§r\n"},{"selector":"@a[tag=op]"}]}`)
                break
            }
            case ('help'): {
                sender.runCommand(`tellraw @s {"rawtext":[{"text":"\n§a§lWilco WorldEdit Commands\n\n§r§7!admins §adisplays all online members with WorldEdit permissions\n\n§r§7!wand §agives you an Edit Wand\n\n§7!brush §aset a structure as a brush\n§7!brush <save/load> <structure name> <include air? true / false>\n\n§7!pos1 §asets first edit coordinate\n\n§7!pos2 §asets second edit coordinate\n\n§7!set §afills between set coordinates\n§7!set <block> <block data> <keep/destroy/hollow/outline>\n§7!set <block> <block data> <replace> <block> <block data>\n\n§7!copy §acopies between set coordinates\n§7!copy <include entities? true / false>\n\n§7!cut §acuts between set coordinates\n§7!cut <include entities? true / false>\n\n§7!paste §apastes copied / cut structure where you are standing\n§7!paste <0, 90, 180, 270 degrees>\n\n§7!pyramid §abuilds a pyramid using specified parameters\n§7!pyramid <block> <block data> <size> <is hollow? true / false>\n\n§7!op §agrants WorldEdit permissions to specified player\n§7!op <player>\n\n§7!deop §arevokes WorldEdit permissions from specified player\n§7!deop <player>"}]}`)
                break
            }
            case ('wand'): {
                sender.runCommand(`give @s wwe:wand`)
                break
            }
            case ('brush'): {
                brush(args[1], args[2], args[3], sender)
                break
            }
            case ('op'): {
                op(sender, args[1], args[2], args[3], args[4])
                break

            }
            case ('deop'): {
                deop(sender, args[1], args[2], args[3], args[4])
                break
            }
            case ('pos1'):
                pos1 = new Position(sender.location.x, sender.location.y, sender.location.z)
                sender.runCommand(`tellraw @s {"rawtext":[{"text":"§dFirst position set: ${pos1.formatted()}"}]}`)
                break

            case ('pos2'): {
                pos2 = new Position(sender.location.x, sender.location.y, sender.location.z)
                sender.runCommand(`tellraw @s {"rawtext":[{"text":"§dSecond position set: ${pos2.formatted()}"}]}`)
                break
            }
            case ('set'): {
                set(args[1], args[2], args[3], args[4], args[5], sender)
                break
            }
            case ('pyramid'): {
                pyramid(args[1], args[2], args[3], args[4], sender)
                break
            }
            case ('copy'): {
                copy(args[1], sender)
                break;
            }
            case ('cut'): {
                cut(args[1], sender)
                break;
            }
            case ('paste'): {
                dopaste(args[1], sender)
                break
            }
            default: {
                sender.runCommand(`tellraw @s {"rawtext":[{"text":"§cUnkown command: ${args[0]}"}]}`)
                break
            }
        }
    }
    else if (output.includes('op') == false && msg.startsWith(`${cmd}`)) {
        sender.runCommand(`tellraw @s {"rawtext":[{"text":"§cYou do not have permission to use this command"}]}`)
        evd.cancel = true
    }

})

function brush(mode = 'load', name = 'null', air = 'true', player) {
    switch (mode) {
        case ('save'): {
            if (name == 'null') {
                name = 'default'
            }
            if (air == 'false') {
                player.runCommand(`fill ${pos1.place()} ${pos2.place()} structure_void 0 replace air 0`)
            }
            player.runCommand(`structure save ${name} ${pos1.place()} ${pos2.place()} false disk`)
            player.runCommand(`tellraw @s {"rawtext":[{"text":"§dBrush save successful"}]}`)
            break
        }
        case ('load'): {
            if (name == 'null') {
                name = 'sphere'
            }
            if (name == 'sphere') {
                brushpos = new Position(-5, -5, -5)
            }
            structure = name
            player.runCommand(`tellraw @s {"rawtext":[{"text":"§dBrush load successful"}]}`)
            break
        }
        default: {
            player.runCommand(`tellraw @s {"rawtext":[{"text":"§cSyntax error: brush mode invalid"}]}`)
            break
        }
    }
}

function op(sender, arg1 = '', arg2 = '', arg3 = '', arg4 = '', choice = 'undefined') {
    var cmdName = []
    if (arg2 == '') {
        cmdName.push(arg1)
    }
    else if (arg3 == '') {
        cmdName.push(arg1, arg2)
    }
    else if (arg4 == '') {
        cmdName.push(arg1, arg2, arg3)
    }
    else {
        cmdName.push(arg1, arg2, arg3, arg4)
    }
    var choice = cmdName.join(' ')
    choice.replace(',', ' ')
    let output = sender.runCommand(`tag "${choice}" list`).statusMessage.replace(/§./g, '').match(/(?<=: ).*$/g)?.[0] ?? ''.split(',')
    if (choice != 'undefined' && choice == `${sender.name}`) {
        sender.runCommand(`tellraw @s {"rawtext":[{"text":"§cYou cannot op yourself"}]}`)
    }
    else if (choice == 'undefined') {
        sender.runCommand(`tellraw @s {"rawtext":[{"text":"§cYou must specify a player"}]}`)
    }
    else if (output.includes('op') == false) {
        sender.runCommand(`tag "${choice}" add op`)
        sender.runCommand(`tellraw @s {"rawtext":[{"text":"§dSuccessfully opped ${choice}"}]}`)
        sender.runCommand(`tellraw "${choice}" {"rawtext":[{"text":"§7You have been opped"}]}`)
    }
    else {
        sender.runCommand(`tellraw @s {"rawtext":[{"text":"§c${choice} is already opped"}]}`)
    }
}

function deop(sender, arg1 = '', arg2 = '', arg3 = '', arg4 = '', choice = 'undefined') {
    var cmdName = []
    if (arg2 == '') {
        cmdName.push(arg1)
    }
    else if (arg3 == '') {
        cmdName.push(arg1, arg2)
    }
    else if (arg4 == '') {
        cmdName.push(arg1, arg2, arg3)
    }
    else {
        cmdName.push(arg1, arg2, arg3, arg4)
    }
    var choice = cmdName.join(' ')
    choice.replace(',', ' ')
    let output = sender.runCommand(`tag "${choice}" list`).statusMessage.replace(/§./g, '').match(/(?<=: ).*$/g)?.[0] ?? ''.split(',')
    if (choice != 'undefined' && choice == `${sender.name}`) {
        sender.runCommand(`tellraw @s {"rawtext":[{"text":"§cYou cannot de-op yourself"}]}`)
    }
    else if (choice == 'undefined') {
        sender.runCommand(`tellraw @s {"rawtext":[{"text":"§cYou must specify a player"}]}`)
    }
    else if (output.includes('op')) {
        sender.runCommand(`tag "${choice}" remove op`)
        sender.runCommand(`tellraw @s {"rawtext":[{"text":"§dSuccessfully de-opped ${choice}"}]}`)
        sender.runCommand(`tellraw "${choice}" {"rawtext":[{"text":"§7You have been de-opped"}]}`)
    }
    else {
        sender.runCommand(`tellraw @s {"rawtext":[{"text":"§c${choice} is already de-opped"}]}`)
    }
}

function set(block = 'stone', blockid1 = '0', mode = ' ', block2 = 'stone', blockid2 = '0', player) {
    if ((mode === 'hollow' || mode === 'destroy' || mode === 'keep' || mode === 'outline' || mode == ' ')) {
        player.runCommand(`fill ${pos1.place()} ${pos2.place()} ${block} ${blockid1} ${mode}`)
        player.runCommand(`tellraw "${player.name}" {"rawtext":[{"text":"§dSet blocks successfully"}]}`)
    }
    else if (mode === 'replace') {
        player.runCommand(`fill ${pos1.place()} ${pos2.place()} ${block} ${blockid1} ${mode} ${block2} ${blockid2}`)
        player.runCommand(`tellraw "${player.name}" {"rawtext":[{"text":"§dSet blocks successfully"}]}`)
    }
}
function copy(include = 'false', player) {
    player.runCommand(`structure save copy ${pos1.place()} ${pos2.place()} ${include} disk`)
    player.runCommand(`tellraw "${player.name}" {"rawtext":[{"text":"§dCopy successful"}]}`)
}

function cut(include = 'false', player) {
    player.runCommand(`structure save copy ${pos1.place()} ${pos2.place()} ${include} disk`)
    player.runCommand(`fill ${pos1.place()} ${pos2.place()} air 0`)
    player.runCommand(`tellraw "${player.name}" {"rawtext":[{"text":"§dCut successful"}]}`)
}

function dopaste(degrees = '0', player) {
    if (degrees == '0' || degrees == '90' || degrees == '180' || degrees == '270') {
        paste = new Position(player.location.x, player.location.y, player.location.z)
        player.runCommand(`structure load copy ${paste.place()} ${degrees}_degrees`)
        player.runCommand(`tellraw "${player.name}" {"rawtext":[{"text":"§dPaste successful"}]}`)
    }
    else {
        player.runCommand(`tellraw "${player.name}" {"rawtext":[{"text":"§cSyntax error: ${degrees}. Degrees must be 0, 90, 180 or 270"}]}`)
    }
}

function pyramid(block = 'stone', id = '0', num = '6', fill = 'false', player) {
    switch (fill) {
        case ('true'): {
            pyrpos = new Position(player.location.x, player.location.y, player.location.z)
            size = num / 1
            for (let n = 0; n <= num; n++) {
                player.runCommand(`fill ${pyrpos.x - size} ${pyrpos.y + n} ${pyrpos.z - size} ${pyrpos.x + size} ${pyrpos.y + n} ${pyrpos.z + size} ${block} ${id}`)
                size--
            }
            size = (num - 1) / 1
            for (let n = 1; n < num; n++) {
                size--
                player.runCommand(`fill ${pyrpos.x - size} ${pyrpos.y + n} ${pyrpos.z - size} ${pyrpos.x + size} ${pyrpos.y + n} ${pyrpos.z + size} air 0`)
            }
            player.runCommand(`tellraw @s {"rawtext":[{"text":"§dPyramid built successfully"}]}`)
            break
        }
        case ('false'): {
            pyrpos = new Position(player.location.x, player.location.y, player.location.z)
            size = num / 1
            for (let n = 0; n <= num; n++) {
                player.runCommand(`fill ${pyrpos.x - size} ${pyrpos.y + n} ${pyrpos.z - size} ${pyrpos.x + size} ${pyrpos.y + n} ${pyrpos.z + size} ${block} ${id}`)
                size--
            }
            player.runCommand(`tellraw @s {"rawtext":[{"text":"§dPyramid built successfully"}]}`)
            break
        }
        default: {
            player.runCommand(`tellraw @s{"rawtext":[{"text":"§cSyntax error: ${args[4]} doesn't exist"}]}`)
            break
        }
    }
}